#include <iostream>
#include "OcclusionQuery.h"
#include "glInterface.h"

using namespace std;


namespace CHCDemo
{

OcclusionQuery::OcclusionQuery()
{
	glGenQueriesARB(1, &mQueryId);

	// reverse for multiequeries with 32 nodes
	mNodes.reserve(32);
}


OcclusionQuery::OcclusionQuery(unsigned int idx):
mQueryId(idx)
{
	// reverse for multiequeries with 32 nodes
	mNodes.reserve(32);
}


OcclusionQuery::~OcclusionQuery()
{
	glDeleteQueriesARB(1, &mQueryId);
}


void OcclusionQuery::BeginQuery()
{
	glBeginQueryARB(GL_SAMPLES_PASSED_ARB, mQueryId);
}


void OcclusionQuery::EndQuery()
{
	glEndQueryARB(GL_SAMPLES_PASSED_ARB);
}


unsigned int OcclusionQuery::GetQueryId() const
{
	return mQueryId;
}


bool OcclusionQuery::ResultAvailable() const
{
	GLuint available = GL_FALSE;

	glGetQueryObjectuivARB(mQueryId, GL_QUERY_RESULT_AVAILABLE_ARB, &available);

	return available == GL_TRUE;
}


unsigned int OcclusionQuery::GetQueryResult() const
{
	GLuint sampleCount = 1;

	glGetQueryObjectuivARB(mQueryId, GL_QUERY_RESULT_ARB, &sampleCount);
	
	return sampleCount;
}

} // namespace
